type image = {
    pixels : string;
    width : int;
    height : int;
    palette : (int * int * int) array 
  } 

exception GifError of string

(* load palette *)
val load_palette : string -> (int * int * int) array

(* quantize a color *)
val get_nearest : (int * int * int) array -> int * int * int -> int

(* load gif file *)
val load : string -> image

(* load image with quantization *)
val load_quantize : (int * int * int) array -> string -> image

