#include <stdio.h>
#include <stdlib.h>
#include <vga.h>
#include <vgamouse.h>
#include <vgakeyboard.h>
#include <mlvalues.h>
#include <alloc.h>
#include <memory.h>

extern unsigned char *graph_mem ;
double *GfxDest ;



value vga_lores_init ()
{
  vga_init () ;
  if (vga_setmode (G320x200x256) == -1) failwith ("vga_setmode") ;
  return (Val_unit) ;
}


value vga_lores_double_buffer_init ()
{
  vga_init () ;
  if (vga_setmode (G320x200x256) == -1) failwith ("vga_setmode") ;
  /* INIT PAR EFFET DE BORD, DE L'ADRESSE DE LA PAGE VGA */
  /* CONSIDEREE COMME UN TABLEAU DE 64000/8 doubles      */
  GfxDest = (double*) graph_mem ;
  return (Val_unit) ;
}


value vga_blit_buffer (StringBuffer)
     value StringBuffer ;
{

#ifdef BCOPY_BLIT
  bcopy (StringBuffer, graph_mem, 64000) ;
#else
  unsigned short Index ;
  double *GfxSrc = (double*) StringBuffer ;

  vga_waitretrace() ;
  for (Index=0;Index<8000;Index++)
    GfxDest[Index] = GfxSrc[Index] ;
#endif

  return (Val_unit) ;
}


value vga_keyboard_init ()
{
  if (keyboard_init () == -1) failwith ("keyboard_init") ;
  return (Val_unit) ;
}


value vga_keyboard_close ()
{
  keyboard_close () ;
  return (Val_unit) ;
}

value vga_lores_close ()
{
  vga_setmode (TEXT) ;
  return (Val_unit) ;
}


value vga_keyboard_update ()
{
  keyboard_update () ;
  return (Val_unit) ;
}


value vga_keyboard_keypressed (ScanCode)
     value ScanCode ;
{
  if (keyboard_keypressed (Int_val (ScanCode)))
   return (Val_int(1)) ;  /* TRUE */
  else
   return (Val_int(0)) ;  /* FALSE */
}


value vga_setpalette_entry (Index, RedComp, GreenComp, BlueComp)
     value Index ;
     value RedComp, GreenComp, BlueComp  ;
{
  vga_setpalette (Int_val (Index), Int_val (RedComp), Int_val (GreenComp),
			   Int_val (BlueComp)) ;
  return (Val_unit) ;
}


value  vga_draw_pixel (x, y)
     int x, y ;
{
  vga_drawpixel (Int_val (x), Int_val (y)) ;
  return (Val_unit) ;
}


value vga_get_pixel (x, y)
     int x, y ;
{
  return (Val_int (vga_getpixel (Int_val (x), Int_val (y)))) ;
}


value vga_draw_line (x1, y1, x2, y2)
     int x1, y1, x2, y2 ;
{
  vga_drawline (Int_val (x1), Int_val (y1), Int_val (x2), Int_val (y2)) ;
  return (Val_unit) ;
}

value vga_screen_off ()
{
  vga_screenoff () ;
  return (Val_unit) ;
}


value vga_screen_on ()
{
  vga_screen_on () ;
  return (Val_unit) ;
}



value vga_get_char ()
{
  int c ;

  c = vga_getch () ;
  /* CHARS ARE ENCODED AS INTS */
  return (Val_int (c)) ;
}


value vga_set_mouse_support (flag)
     int flag ;
{
  vga_setmousesupport (Int_val (flag)) ;
  return (Val_unit) ;
}


value vga_mouse_update ()
{
  if (mouse_update ())
    return (Val_int(1)) ;    /* true = MOUSE POSITION CHANGED */
  else
    return (Val_int(0)) ;    /* false = NOTHING NEW */
}


value vga_mouse_getx ()
{
  return (Val_int (mouse_getx ())) ;
}


value vga_mouse_gety ()
{
  return (Val_int (mouse_gety ())) ;
}


value vga_mouse_get_button ()
{
  switch (mouse_getbutton ())
    {
    case MOUSE_LEFTBUTTON:
      return (Val_int (1)) ;
      break ;
    case MOUSE_MIDDLEBUTTON:
      return (Val_int (2)) ;
      break ;
    case MOUSE_RIGHTBUTTON:
      return (Val_int (3)) ;
      break ;
    case (MOUSE_LEFTBUTTON | MOUSE_MIDDLEBUTTON):
      return (Val_int (4)) ;
      break ;
    case (MOUSE_LEFTBUTTON | MOUSE_RIGHTBUTTON):
      return (Val_int (5)) ;
      break ;
    case (MOUSE_MIDDLEBUTTON | MOUSE_RIGHTBUTTON):
      return (Val_int (6)) ;
      break ;
    case (MOUSE_LEFTBUTTON | MOUSE_MIDDLEBUTTON | MOUSE_RIGHTBUTTON):
      return (Val_int (7)) ;
      break ;
    default:
      return (Val_int (0)) ;
      break ;
    }
}


value vga_mouse_set_position (x, y)
     int x, y ;
{
  mouse_setposition (Int_val (x), Int_val (y)) ;
  return (Val_unit) ;
}



value vga_set_color (color)
     int color ;
{
  vga_setcolor (Int_val (color)) ;
  return (Val_unit) ;  
}
