(* INITIALIZE SVGALIB IN 320x200. *)
external vga_lores_init : unit -> unit
                     = "vga_lores_init" ;;

(* INITIALIZE SVGALIB IN 320x200 WITH A DOUBLE BUFFER. *)
external vga_lores_double_buffer_init : unit -> unit
                     = "vga_lores_double_buffer_init" ;;

(* BLITS A DOUBLE-BUFFER TO A LORES VGA VIDEO MEMORY *)
external vga_blit_buffer : string -> unit
                  = "vga_blit_buffer" ;;

(* SETUP KEYBOARD HANDLERS *)
external vga_keyboard_init : unit -> unit
                  = "vga_keyboard_init" ;;

(* REMOVE KEYBOARD HANDLERS *)
external vga_keyboard_close : unit -> unit
                 = "vga_keyboard_close" ;;

(* QUIT VGA MODES AND RESTORE TEXT MODE *)
external vga_lores_close : unit -> unit
                      = "vga_lores_close";;

(* UPDATE KEYPRESS EVENTS *)
external vga_keyboard_update : unit -> unit
                   = "vga_keyboard_update" ;;

(* TEST IF A KEY HAS BEEN PRESSED *)
external vga_keyboard_keypressed : int -> bool
                   = "vga_keyboard_keypressed" ;;

(* SET A PALETTE ENTRY *)
external vga_setpalette_entry : int -> int -> int -> int -> unit
                   = "vga_setpalette_entry" ;;

(* DRAW A SINGLE PIXEL IN VIDEO MEMORY *)
external vga_draw_pixel : int -> int -> unit
                   = "vga_draw_pixel" ;;

(* GET A POINT'S COLOR NULBER *)
external vga_get_pixel : int -> int -> int
                   = "vga_get_pixel" ;;

(* DRAW A LINE IN VIDEO MEMORY *)
external vga_draw_line : int -> int -> int -> int -> unit
                   = "vga_draw_line" ;;

(* DISABLE SCREEN REFRESH *)
external vga_screen_off : unit -> unit
                  = "vga_screen_off " ;;

(* ENABLE SCREEN REFRESH  *)
external vga_screen_on : unit -> unit
                   = "vga_screen_on" ;;

(* WAIT FOR A CHARACTER *)
external vga_get_char : unit -> char
                   = "vga_get_char" ;;

(* SET CURRENT DRAWING COLOR TO A SPECIFIED COLOR *)
external vga_set_color : int -> unit
                   = "vga_set_color" ;;


type mouseInitMode =
 | MOUSE_DISABLE
 | MOUSE_ENABLE
;;


(* ENABLE/DISABLE AUTOMATIC MOUSE SUPPORT ONCE VIDEO MODE IS CHOOSEN. *)
external vga_set_mouse_support : mouseInitMode -> unit
                    = "vga_set_mouse_support" ;;


(* UPDATE MOUSE. RETURN TRUE IF POSITION CHANGED, OTHERWISE FALSE *)
external vga_mouse_update : unit -> bool
                    = "vga_mouse_update" ;;

(* GET CURRENT MOUSE x POSITION (CALL vga_mouse_update BEFORE) *)
external vga_mouse_getx : unit -> int
                    = "vga_mouse_getx" ;;

(* GET CURRENT MOUSE x POSITION (CALL vga_mouse_update BEFORE) *)
external vga_mouse_gety : unit -> int
                    = "vga_mouse_gety" ;;

(* SET MOUSE POSITION *)
external vga_mouse_set_position : int -> int -> unit
                    = "vga_mouse_set_position" ;;


type mouseButtonStatus =
 | NO_BUTTONPRESS
 | LEFT
 | MIDDLE
 | RIGHT
 | LEFT_MIDDLE
 | LEFT_RIGHT
 | MIDDLE_RIGHT
 | LEFT_MIDDLE_RIGHT
;;

(* GET CURRENT BUTTONS STATUS *)
external vga_mouse_get_button : unit -> mouseButtonStatus
                    = "vga_mouse_get_button" ;;
